import Common = require("./common");
export declare enum ParameterLocation {
    QUERY = 0,
    HEADERS = 1,
    URI = 2,
    FORM = 3,
    BURI = 4,
}
export declare class Parameter extends Common.RAMLLanguageElement {
    name: string;
    $name: void[];
    displayName: string;
    $displayName: void[];
    type: string;
    $type: void[];
    location: ParameterLocation;
    $location: void[];
    required: boolean;
    $required: void[];
    default: any;
    $default: void[];
    example: string;
    $example: void[];
    repeat: boolean;
    $repeat: void[];
    $: any[];
}
export declare class StringTypeDeclaration extends Parameter {
    pattern: string;
    $pattern: void[];
    enum: string[];
    $enum: void[];
    minLength: number;
    $minLength: void[];
    maxLength: number;
    $maxLength: void[];
    type: string;
    $: void[];
}
export declare class BooleanTypeDeclaration extends Parameter {
    type: string;
    $: void[];
}
export declare class NumberTypeDeclaration extends Parameter {
    type: string;
    minimum: number;
    $minimum: void[];
    maximum: number;
    $maximum: void[];
    $: void[];
}
export declare class IntegerTypeDeclaration extends NumberTypeDeclaration {
    type: string;
    $: void[];
}
export declare class DateTypeDeclaration extends Parameter {
    type: string;
    $: void[];
}
export declare class FileTypeDeclaration extends Parameter {
    type: string;
    $: void[];
}
export declare class HasNormalParameters extends Common.RAMLLanguageElement {
    queryParameters: Parameter[];
    displayName: string;
    $displayName: void[];
    $queryParameters: void[];
    headers: Parameter[];
    $headers: void[];
}
