var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var Common = require("./common");
var models = require("./datamodel");
var GlobalSchema = (function (_super) {
    __extends(GlobalSchema, _super);
    function GlobalSchema() {
        _super.apply(this, arguments);
        this.$key = [MetaModel.key(), MetaModel.description("Name of the global schema, used to refer on schema content")];
        this.$value = [MetaModel.description("Content of the schema"), MetaModel.canBeValue(), MetaModel.value()];
        this.$ = [MetaModel.actuallyExports("value"), MetaModel.description("Content of the schema")];
    }
    return GlobalSchema;
})(Common.RAMLSimpleElement);
exports.GlobalSchema = GlobalSchema;
var ImportDeclaration = (function (_super) {
    __extends(ImportDeclaration, _super);
    function ImportDeclaration() {
        _super.apply(this, arguments);
        this.$key = [MetaModel.key(), MetaModel.description("Name prefix (without dot) used to refer imported declarations")];
        this.$value = [MetaModel.description("Content of the declared namespace")];
    }
    return ImportDeclaration;
})(Common.RAMLSimpleElement);
exports.ImportDeclaration = ImportDeclaration;
var Library = (function (_super) {
    __extends(Library, _super);
    function Library() {
        _super.apply(this, arguments);
        this.$usage = [MetaModel.description("contains description of why library exist")];
        this.$name = [MetaModel.key(), MetaModel.description("Namespace which the library is imported under")];
    }
    return Library;
})(LibraryBase);
exports.Library = Library;
var LibraryBase = (function (_super) {
    __extends(LibraryBase, _super);
    function LibraryBase() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.internalClass()];
        this.$schemas = [
            MetaModel.embeddedInMaps(),
            MetaModel.description("Alias for the equivalent \"types\" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the \"types\" property, as the \"schemas\" alias for that property name may be removed in a future RAML version. The \"types\" property allows for XML and JSON schemas.")
        ];
        this.$types = [MetaModel.embeddedInMaps(),
            MetaModel.setsContextValue("locationKind", models.LocationKind.MODELS),
            MetaModel.description("Declarations of (data) types for use within this API"),
            MetaModel.markdownDescription("Declarations of (data) types for use within this API. See [[raml-10-spec-types|Types]]."),
            MetaModel.valueDescription("An object whose properties map type names to type declarations; or an array of such objects")
        ];
        this.$traits = [
            MetaModel.embeddedInMaps(), MetaModel.description("Declarations of traits used in this API"),
            MetaModel.description("Declarations of traits for use within this API"),
            MetaModel.markdownDescription("Declarations of traits for use within this API. See [[raml-10-spec-resource-types-and-traits|Resource Types and Traits]]."),
            MetaModel.valueDescription("An object whose properties map trait names to trait declarations; or an array of such objects")
        ];
        this.$resourceTypes = [
            MetaModel.embeddedInMaps(), MetaModel.description("Declaration of resource types used in this API"),
            MetaModel.description("Declarations of resource types for use within this API"),
            MetaModel.markdownDescription("Declarations of resource types for use within this API. See [[raml-10-spec-resource-types-and-traits|Resource Types and Traits]]."),
            MetaModel.valueDescription("An object whose properties map resource type names to resource type declarations; or an array of such objects")
        ];
        this.$annotationTypes = [
            MetaModel.setsContextValue("decls", "true"),
            MetaModel.embeddedInMaps(),
            MetaModel.description("Declarations of annotation types for use by annotations"),
            MetaModel.markdownDescription("Declarations of annotation types for use by annotations. See [[raml-10-spec-declaring-annotation-types|Annotation Types]]."),
            MetaModel.valueDescription("An object whose properties map annotation type names to annotation type declarations; or an array of such objects")
        ];
        this.$securitySchemes = [
            MetaModel.embeddedInMaps(),
            MetaModel.description("Security schemas declarations"),
            MetaModel.description("Declarations of security schemes for use within this API."),
            MetaModel.markdownDescription("Declarations of security schemes for use within this API. See [[raml-10-spec-security|Security Schemes]]."),
            MetaModel.valueDescription("An object whose properties map security scheme names to security scheme declarations; or an array of such objects")
        ];
        this.$uses = [
            MetaModel.embeddedInMaps(),
            MetaModel.description("Importing libraries"),
            MetaModel.setsContextValue("decls", "true"),
            MetaModel.valueDescription("An array of libraries or a single library")
        ];
    }
    return LibraryBase;
})(Common.RAMLLanguageElement);
exports.LibraryBase = LibraryBase;
var Overlay = (function (_super) {
    __extends(Overlay, _super);
    function Overlay() {
        _super.apply(this, arguments);
        this.$usage = [MetaModel.description("contains description of why overlay exist")];
        this.$masterRef = [
            MetaModel.required(),
            MetaModel.description("Location of a valid RAML API definition (or overlay or extension), the overlay is applied to,")
        ];
        this.$title = [MetaModel.description("Short plain-text label for the API")];
    }
    return Overlay;
})(Api);
var Extension = (function (_super) {
    __extends(Extension, _super);
    function Extension() {
        _super.apply(this, arguments);
        this.$usage = [MetaModel.description("contains description of why extension exist")];
        this.$masterRef = [
            MetaModel.required(),
            MetaModel.description("Location of a valid RAML API definition (or overlay or extension), the extension is applied to,")
        ];
        this.$title = [MetaModel.description("Short plain-text label for the API")];
    }
    return Extension;
})(Api);
var Api = (function (_super) {
    __extends(Api, _super);
    function Api() {
        _super.apply(this, arguments);
        this.$title = [MetaModel.required(), MetaModel.description("Short plain-text label for the API")];
        this.$version = [MetaModel.description("The version of the API, e.g. \"v1\"")];
        this.$baseUri = [
            MetaModel.description("A URI that's to be used as the base of all the resources' URIs. Often used as the base of the URL of each resource, containing the location of the API. Can be a template URI.")
        ];
        this.$baseUriParameters = [
            MetaModel.setsContextValue("location", models.ModelLocation.BURI),
            MetaModel.setsContextValue("locationKind", models.LocationKind.APISTRUCTURE),
            MetaModel.description("Named parameters used in the baseUri (template)")
        ];
        this.$protocols = [
            MetaModel.oneOf(["HTTP", "HTTPS"]),
            MetaModel.description("The protocols supported by the API"),
            MetaModel.valueDescription("Array of strings, with each being \"HTTP\" or \"HTTPS\", case-insensitive")
        ];
        this.$mediaType = [
            MetaModel.oftenKeys(["application/json", "application/xml",
                "application/x-www-form-urlencoded",
                "multipart/form-data"]),
            MetaModel.description("The default media type to use for request and response bodies (payloads), e.g. \"application/json\""),
            MetaModel.inherited(),
            MetaModel.valueDescription("Media type string")
        ];
        this.$securedBy = [
            MetaModel.description("The security schemes that apply to every resource and method in the API")
        ];
        this.$resources = [MetaModel.documentationTableLabel("/&lt;relativeUri&gt;"),
            MetaModel.newInstanceName("New Resource"),
            MetaModel.description("The resources of the API, identified as relative URIs that begin with a slash (/). Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property, e.g.: /users, /{groupId}, etc")
        ];
        this.$documentation = [
            MetaModel.description("Additional overall documentation for the API")
        ];
        this.$displayName = [MetaModel.hide()];
        this.$description = [MetaModel.description("A longer, human-friendly description of the API")];
        this.$annotations = [
            MetaModel.markdownDescription("Annotations to be applied to this API. Annotations are any property whose key begins with \"(\" and ends with \")\" and whose name (the part between the beginning and ending parentheses) is a declared annotation name. See the [[raml-10-spec-annotations|section on annotations]].")
        ];
        this.$RAMLVersion = [MetaModel.customHandling(), MetaModel.description("Returns RAML version. \"RAML10\" string is returned for RAML 1.0. \"RAML08\" string is returned for RAML 0.8.")];
    }
    return Api;
})(LibraryBase);
var DocumentationItem = (function (_super) {
    __extends(DocumentationItem, _super);
    function DocumentationItem() {
        _super.apply(this, arguments);
        this.$title = [
            MetaModel.description("Title of documentation section"),
            MetaModel.required()
        ];
        this.$content = [
            MetaModel.description("Content of documentation section"),
            MetaModel.required()
        ];
    }
    return DocumentationItem;
})(Common.RAMLLanguageElement);
//# sourceMappingURL=api.js.map