var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var Common = require("./common");
(function (ModelLocation) {
    ModelLocation[ModelLocation["QUERY"] = 0] = "QUERY";
    ModelLocation[ModelLocation["HEADERS"] = 1] = "HEADERS";
    ModelLocation[ModelLocation["URI"] = 2] = "URI";
    ModelLocation[ModelLocation["FORM"] = 3] = "FORM";
    ModelLocation[ModelLocation["BURI"] = 4] = "BURI";
    ModelLocation[ModelLocation["ANNOTATION"] = 5] = "ANNOTATION";
    ModelLocation[ModelLocation["MODEL"] = 6] = "MODEL";
    ModelLocation[ModelLocation["SECURITYSCHEMATYPE"] = 7] = "SECURITYSCHEMATYPE";
})(exports.ModelLocation || (exports.ModelLocation = {}));
var ModelLocation = exports.ModelLocation;
(function (LocationKind) {
    LocationKind[LocationKind["APISTRUCTURE"] = 0] = "APISTRUCTURE";
    LocationKind[LocationKind["DECLARATIONS"] = 1] = "DECLARATIONS";
    LocationKind[LocationKind["MODELS"] = 2] = "MODELS";
})(exports.LocationKind || (exports.LocationKind = {}));
var LocationKind = exports.LocationKind;
var ExampleSpec = (function (_super) {
    __extends(ExampleSpec, _super);
    function ExampleSpec() {
        _super.apply(this, arguments);
        this.$content = [
            MetaModel.selfNode(),
            MetaModel.description("String representation of example"),
            MetaModel.required(),
            MetaModel.valueDescription("* Valid value for this type<br>* String representing the serialized version of a valid value")
        ];
        this.$structuredContent = [MetaModel.customHandling(), MetaModel.description("Returns object representation of example, if possible")];
        this.$strict = [MetaModel.description("By default, examples are validated against any type declaration. Set this to false to allow examples that need not validate.")];
        this.$name = [MetaModel.key(), MetaModel.hide(), MetaModel.description("Example identifier, if specified")];
        this.$displayName = [MetaModel.description("An alternate, human-friendly name for the example")];
        this.$description = [
            MetaModel.description("A longer, human-friendly description of the example"),
            MetaModel.valueDescription("markdown string")
        ];
        this.$annotations = [
            MetaModel.markdownDescription("Annotations to be applied to this example. Annotations are any property whose key begins with \"(\" and ends with \")\" and whose name (the part between the beginning and ending parentheses) is a declared annotation name. See the [[raml-10-spec-annotations|section on annotations]].")
        ];
    }
    return ExampleSpec;
})(Common.RAMLLanguageElement);
exports.ExampleSpec = ExampleSpec;
var DataElementProperty = (function () {
    function DataElementProperty() {
        this.$name = [
            MetaModel.key(),
            MetaModel.description("name of the parameter"),
            MetaModel.extraMetaKey("headers"),
            MetaModel.hide()
        ];
        this.$location = [
            MetaModel.system(), MetaModel.description("Location of the parameter (can not be edited by user)"),
            MetaModel.hide()
        ];
        this.$locationKind = [
            MetaModel.system(), MetaModel.description("Kind of location"),
            MetaModel.hide()
        ];
        this.$default = [
            MetaModel.description("Provides default value for a property"),
            MetaModel.valueDescription("any")
        ];
        this.$required = [
            MetaModel.requireValue("fieldOrParam", true),
            MetaModel.description("Sets if property is optional or not"),
            MetaModel.describesAnnotation("required"),
            MetaModel.valueDescription("boolean = true")
        ];
    }
    return DataElementProperty;
})();
exports.DataElementProperty = DataElementProperty;
var TypeDeclaration = (function (_super) {
    __extends(TypeDeclaration, _super);
    function TypeDeclaration() {
        _super.apply(this, arguments);
        this.$name = [
            MetaModel.key(),
            MetaModel.description("name of the parameter"),
            MetaModel.extraMetaKey("headers"),
            MetaModel.hide()
        ];
        this.$facets = [
            MetaModel.declaringFields(),
            MetaModel.description("When extending from a type you can define new facets (which can then be set to concrete values by subtypes)."),
            MetaModel.hide()
        ];
        this.$fixedFacets = [MetaModel.customHandling(), MetaModel.description("Returns facets fixed by the type. Value is an object with properties named after facets fixed. Value of each property is a value of the corresponding facet.")];
        this.$schema = [
            MetaModel.description("Alias for the equivalent \"type\" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the \"type\" property, as the \"schema\" alias for that property name may be removed in a future RAML version. The \"type\" property allows for XML and JSON schemas."),
            MetaModel.valueDescription("Single string denoting the base type or type expression")
        ];
        this.$schemaContent = [MetaModel.customHandling(), MetaModel.description("Returns schema content for the cases when schema is inlined, when schema is included, and when schema is a reference.")];
        this.$type = [
            MetaModel.allowMultiple(),
            MetaModel.canBeValue(),
            MetaModel.defaultValue("string"),
            MetaModel.descriminatingProperty(),
            MetaModel.description("A base type which the current type extends, or more generally a type expression."),
            MetaModel.valueDescription("string denoting the base type or type expression")
        ];
        this.$location = [
            MetaModel.system(),
            MetaModel.description("Location of the parameter (can not be edited by user)"),
            MetaModel.hide()
        ];
        this.$locationKind = [
            MetaModel.system(), MetaModel.description("Kind of location"),
            MetaModel.hide()
        ];
        this.$default = [
            MetaModel.description("Provides default value for a property"),
            MetaModel.hide()
        ];
        this.$example = [
            MetaModel.selfNode(),
            MetaModel.description("An example of this type instance represented as string. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the examples property is present."),
            MetaModel.valueDescription("* Valid value for this type<br>* String representing the serialized version of a valid value")
        ];
        this.$structuredExample = [MetaModel.customHandling(), MetaModel.description("Returns object representation of example, if possible")];
        this.$examples = [
            MetaModel.description("An object containing named examples of instances of this type. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the examples property is present."),
            MetaModel.valueDescription("An object whose properties map example names to Example objects (see [[raml-10-spec-examples|Examples]] section); or an array of Example objects.")
        ];
        this.$repeat = [
            MetaModel.requireValue("fieldOrParam", true),
            MetaModel.description("The repeat attribute specifies that the parameter can be repeated. " +
                "If the parameter can be used multiple times, the repeat parameter value MUST be set to 'true'. Otherwise, the default value is 'false' and the parameter may not be repeated."),
            MetaModel.defaultBooleanValue(false),
            MetaModel.hide()
        ];
        this.$required = [
            MetaModel.requireValue("fieldOrParam", true),
            MetaModel.description("Sets if property is optional or not"),
            MetaModel.describesAnnotation("required"),
            MetaModel.hide(),
            MetaModel.defaultBooleanValue(true)
        ];
        this.$ = [MetaModel.convertsToGlobalOfType("SchemaString"), MetaModel.canInherit("mediaType")];
        this.$displayName = [MetaModel.description("An alternate, human-friendly name for the type")];
        this.$description = [
            MetaModel.description("A longer, human-friendly description of the type"),
            MetaModel.valueDescription("markdown string")
        ];
        this.$annotations = [
            MetaModel.markdownDescription("Annotations to be applied to this type. Annotations are any property whose key begins with \"(\" and ends with \")\" and whose name (the part between the beginning and ending parentheses) is a declared annotation name. See the [[raml-10-spec-annotations|section on annotations]].")
        ];
    }
    return TypeDeclaration;
})(Common.RAMLLanguageElement);
exports.TypeDeclaration = TypeDeclaration;
var ScalarElement = (function () {
    function ScalarElement() {
        this.$facets = [
            MetaModel.declaringFields(),
            MetaModel.description("When extending from a scalar type you can define new facets (which can then be set to concrete values by subtypes)."),
            MetaModel.valueDescription("An object whose properties map facets names to their types.")
        ];
        this.$enum = [
            MetaModel.describesAnnotation("oneOf"),
            MetaModel.description("Enumeration of possible values for this primitive type. Cannot be used with the file type."),
            MetaModel.valueDescription("Array containing string representations of possible values, or a single string if there is only one possible value.")
        ];
    }
    return ScalarElement;
})();
exports.ScalarElement = ScalarElement;
var ArrayTypeDeclaration = (function (_super) {
    __extends(ArrayTypeDeclaration, _super);
    function ArrayTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "array";
        this.$uniqueItems = [
            MetaModel.facetId("uniqueItems"),
            MetaModel.description("Should items in array be unique")
        ];
        this.$items = [
            MetaModel.description("Array component type."),
            MetaModel.valueDescription("Inline type declaration or type name.")
        ];
        this.$minItems = [
            MetaModel.facetId("minItems"),
            MetaModel.description("Minimum amount of items in array"),
            MetaModel.valueDescription("integer ( >= 0 ). Defaults to 0")
        ];
        this.$maxItems = [
            MetaModel.facetId("maxItems"),
            MetaModel.description("Maximum amount of items in array"),
            MetaModel.valueDescription("integer ( >= 0 ). Defaults to undefined.")
        ];
        this.$ = [
            MetaModel.convertsToGlobalOfType("SchemaString"),
            MetaModel.alias("array"),
            MetaModel.declaresSubTypeOf("TypeDeclaration")];
    }
    return ArrayTypeDeclaration;
})(TypeDeclaration);
exports.ArrayTypeDeclaration = ArrayTypeDeclaration;
var UnionTypeDeclaration = (function (_super) {
    __extends(UnionTypeDeclaration, _super);
    function UnionTypeDeclaration() {
        _super.apply(this, arguments);
        this.$discriminator = [
            MetaModel.description("Type property name to be used as a discriminator or boolean")
        ];
        this.type = "union";
        this.$ = [MetaModel.convertsToGlobalOfType("SchemaString"), MetaModel.requireValue("locationKind", LocationKind.MODELS), MetaModel.declaresSubTypeOf("TypeDeclaration")];
    }
    return UnionTypeDeclaration;
})(TypeDeclaration);
exports.UnionTypeDeclaration = UnionTypeDeclaration;
var ObjectTypeDeclaration = (function (_super) {
    __extends(ObjectTypeDeclaration, _super);
    function ObjectTypeDeclaration() {
        _super.apply(this, arguments);
        this.$properties = [
            MetaModel.setsContextValue("fieldOrParam", true),
            MetaModel.description("The properties that instances of this type may or must have."),
            MetaModel.valueDescription("An object whose keys are the properties' names and whose values are property declarations.")
        ];
        this.$minProperties = [
            MetaModel.facetId("minProperties"),
            MetaModel.description("The minimum number of properties allowed for instances of this type.")
        ];
        this.$maxProperties = [
            MetaModel.facetId("maxProperties"),
            MetaModel.description("The maximum number of properties allowed for instances of this type.")
        ];
        this.$additionalProperties = [
            MetaModel.description("JSON schema style syntax for declaring maps"),
            MetaModel.markdownDescription("JSON schema style syntax for declaring maps. See [[raml-10-spec-map-types|Map Types]]."),
            MetaModel.valueDescription("Inline type declaration or typename")
        ];
        this.$patternProperties = [
            MetaModel.description("JSON schema style syntax for declaring key restricted maps"),
            MetaModel.markdownDescription("JSON schema style syntax for declaring key restricted maps. See [[raml-10-spec-map-types|Map Types]]."),
            MetaModel.valueDescription("An object whose properties map regular expressions (which are regarded as defining ranges for property names) to types of properties expressed as Inline type declaration or typename.")
        ];
        this.$discriminator = [
            MetaModel.description("Type property name to be used as discriminator, or boolean")
        ];
        this.$discriminatorValue = [
            MetaModel.description("The value of discriminator for the type.")
        ];
        this.type = "object";
        this.$type = [MetaModel.hide()];
        this.$ = [
            MetaModel.definingPropertyIsEnough("properties"),
            MetaModel.setsContextValue("field", "true"),
            MetaModel.convertsToGlobalOfType("SchemaString"),
            MetaModel.declaresSubTypeOf("TypeDeclaration")
        ];
    }
    return ObjectTypeDeclaration;
})(TypeDeclaration);
exports.ObjectTypeDeclaration = ObjectTypeDeclaration;
var StringTypeDeclaration = (function (_super) {
    __extends(StringTypeDeclaration, _super);
    function StringTypeDeclaration() {
        _super.apply(this, arguments);
        this.$pattern = [
            MetaModel.facetId("pattern"),
            MetaModel.description("Regular expression that this string should path"),
            MetaModel.valueDescription("regexp")
        ];
        this.$minLength = [
            MetaModel.facetId("minLength"),
            MetaModel.description("Minimum length of the string")];
        this.$maxLength = [
            MetaModel.facetId("maxLength"),
            MetaModel.description("Maximum length of the string")];
        this.type = "string";
        this.$ = [MetaModel.description("Value must be a string"), MetaModel.declaresSubTypeOf("TypeDeclaration")];
        this.$enum = [
            MetaModel.facetId("enum"),
            MetaModel.describesAnnotation("oneOf"),
            MetaModel.description("(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."),
            MetaModel.hide()
        ];
    }
    return StringTypeDeclaration;
})(TypeDeclaration);
exports.StringTypeDeclaration = StringTypeDeclaration;
var BooleanTypeDeclaration = (function (_super) {
    __extends(BooleanTypeDeclaration, _super);
    function BooleanTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "boolean";
        this.$ = [MetaModel.description("Value must be a boolean"), MetaModel.declaresSubTypeOf("TypeDeclaration")];
    }
    return BooleanTypeDeclaration;
})(TypeDeclaration);
exports.BooleanTypeDeclaration = BooleanTypeDeclaration;
var ValueTypeDeclaration = (function (_super) {
    __extends(ValueTypeDeclaration, _super);
    function ValueTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "value";
        this.$ = [MetaModel.description("Value must be a boolean"), MetaModel.declaresSubTypeOf("TypeDeclaration")];
    }
    return ValueTypeDeclaration;
})(TypeDeclaration);
exports.ValueTypeDeclaration = ValueTypeDeclaration;
var NumberTypeDeclaration = (function (_super) {
    __extends(NumberTypeDeclaration, _super);
    function NumberTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "number";
        this.$minimum = [MetaModel.facetId("minimum"), MetaModel.description("(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value.")];
        this.$maximum = [MetaModel.facetId("maximum"), MetaModel.description("(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value.")];
        this.$ = [MetaModel.description("Value MUST be a number. Indicate floating point numbers as defined by YAML."), MetaModel.declaresSubTypeOf("TypeDeclaration")];
        this.$enum = [
            MetaModel.facetId("enum"),
            MetaModel.describesAnnotation("oneOf"),
            MetaModel.description("(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."),
            MetaModel.hide()
        ];
        this.$format = [
            MetaModel.oneOf(["int32", "int64", "int", "long", "float", "double", "int16", "int8"]),
            MetaModel.description("Value format")
        ];
        this.$multipleOf = [MetaModel.description('A numeric instance is valid against "multipleOf" if the result of the division of the instance by this keyword\'s value is an integer.')];
    }
    return NumberTypeDeclaration;
})(TypeDeclaration);
exports.NumberTypeDeclaration = NumberTypeDeclaration;
var IntegerTypeDeclaration = (function (_super) {
    __extends(IntegerTypeDeclaration, _super);
    function IntegerTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "integer";
        this.$ = [MetaModel.description("Value MUST be a integer."), MetaModel.declaresSubTypeOf("TypeDeclaration")];
        this.$format = [
            MetaModel.oneOf(["int32", "int64", "int", "long", "int16", "int8"]),
            MetaModel.description("Value format")
        ];
    }
    return IntegerTypeDeclaration;
})(NumberTypeDeclaration);
exports.IntegerTypeDeclaration = IntegerTypeDeclaration;
var RAMLExpression = (function (_super) {
    __extends(RAMLExpression, _super);
    function RAMLExpression() {
        _super.apply(this, arguments);
        this.type = "ramlexpression";
        this.$ = [MetaModel.requireValue("locationKind", LocationKind.APISTRUCTURE), MetaModel.requireValue("location", ModelLocation.ANNOTATION)];
    }
    return RAMLExpression;
})(TypeDeclaration);
exports.RAMLExpression = RAMLExpression;
var SchemaElement = (function (_super) {
    __extends(SchemaElement, _super);
    function SchemaElement() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.requireValue("locationKind", LocationKind.APISTRUCTURE), MetaModel.nameAtRuntime("SchemaString")];
        this.type = "schema";
    }
    return SchemaElement;
})(TypeDeclaration);
exports.SchemaElement = SchemaElement;
var DateTypeDeclaration = (function (_super) {
    __extends(DateTypeDeclaration, _super);
    function DateTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "date";
        this.$ = [MetaModel.description("Value MUST be a string representation of a date as defined in RFC2616 Section 3.3 [RFC2616]. or according to specified date format"), MetaModel.declaresSubTypeOf("TypeDeclaration")];
    }
    return DateTypeDeclaration;
})(TypeDeclaration);
exports.DateTypeDeclaration = DateTypeDeclaration;
var TypeInstance = (function () {
    function TypeInstance() {
        this.$ = [MetaModel.customHandling()];
        this.$properties = [MetaModel.description("Array of instance properties")];
        this.$isScalar = [MetaModel.description("Whether the type is scalar")];
        this.$value = [MetaModel.description("For instances of scalar types returns scalar value")];
    }
    return TypeInstance;
})();
exports.TypeInstance = TypeInstance;
var TypeInstanceProperty = (function () {
    function TypeInstanceProperty() {
        this.$ = [MetaModel.customHandling()];
        this.$name = [MetaModel.description("Property name")];
        this.$value = [MetaModel.description("Property value")];
        this.$values = [MetaModel.description("Array of values if property value is array")];
        this.$isArray = [MetaModel.description("Whether property has array as value")];
    }
    return TypeInstanceProperty;
})();
exports.TypeInstanceProperty = TypeInstanceProperty;
//# sourceMappingURL=datamodel.js.map