var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var Sys = require("./systemTypes");
var datamodel = require("./datamodel");
var AnnotationTypeDeclaration = (function (_super) {
    __extends(AnnotationTypeDeclaration, _super);
    function AnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$allowMultiple = [
            MetaModel.description("Whether multiple instances of annotations of this type may be applied simultaneously at the same location")
        ];
        this.$allowedTargets = [
            MetaModel.oneOf([
                "API",
                "DocumentationItem",
                "Resource",
                "Method",
                "Response",
                "RequestBody",
                "ResponseBody",
                "TypeDeclaration",
                "NamedExample",
                "ResourceType",
                "Trait",
                "SecurityScheme",
                "SecuritySchemeSettings",
                "AnnotationTypeDeclaration",
                "Library",
                "Overlay",
                "Extension"
            ]),
            MetaModel.description("Restrictions on where annotations of this type can be applied. If this property is specified, annotations of this type may only be applied on a property corresponding to one of the target names specified as the value of this property."),
            MetaModel.valueDescription("An array of names (or a single name) from the list of Target Names in the [[raml-10-spec-target-locations-table|Target Locations table]]  below. ")
        ];
        this.$usage = [
            MetaModel.description("Instructions on how and when to use this annotation in a RAML spec."),
            MetaModel.valueDescription("Markdown string")
        ];
        this.$ = [
            MetaModel.declaresSubTypeOf("Annotation"),
            MetaModel.declaresSubTypeOf("AnnotationTypeDeclaration")
        ];
    }
    return AnnotationTypeDeclaration;
})(datamodel.TypeDeclaration);
exports.AnnotationTypeDeclaration = AnnotationTypeDeclaration;
var AnnotationRef = (function (_super) {
    __extends(AnnotationRef, _super);
    function AnnotationRef() {
        _super.apply(this, arguments);
        this.$ = [
            MetaModel.description("Annotations allow you to attach information to your API"),
            MetaModel.tags(['annotations'])
        ];
        this.$annotation = [MetaModel.customHandling(), MetaModel.description("Returns referenced annotation")];
    }
    return AnnotationRef;
})(Sys.Reference);
exports.AnnotationRef = AnnotationRef;
var AnnotationTarget = (function (_super) {
    __extends(AnnotationTarget, _super);
    function AnnotationTarget() {
        _super.apply(this, arguments);
        this.$ = [
            MetaModel.description("Elements to which this Annotation can be applied (enum)"),
            MetaModel.tags(['annotations'])
        ];
    }
    return AnnotationTarget;
})(Sys.ValueType);
exports.AnnotationTarget = AnnotationTarget;
var Annotation = (function () {
    function Annotation() {
        this.$name = [MetaModel.key()];
    }
    return Annotation;
})();
exports.Annotation = Annotation;
var ArrayAnnotationTypeDeclaration = (function (_super) {
    __extends(ArrayAnnotationTypeDeclaration, _super);
    function ArrayAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["AnnotationTypeDeclaration"])];
    }
    return ArrayAnnotationTypeDeclaration;
})(datamodel.ArrayTypeDeclaration);
exports.ArrayAnnotationTypeDeclaration = ArrayAnnotationTypeDeclaration;
var UnionAnnotationTypeDeclaration = (function (_super) {
    __extends(UnionAnnotationTypeDeclaration, _super);
    function UnionAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["AnnotationTypeDeclaration"])];
    }
    return UnionAnnotationTypeDeclaration;
})(datamodel.UnionTypeDeclaration);
exports.UnionAnnotationTypeDeclaration = UnionAnnotationTypeDeclaration;
var ObjectAnnotationTypeDeclaration = (function (_super) {
    __extends(ObjectAnnotationTypeDeclaration, _super);
    function ObjectAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["AnnotationTypeDeclaration"])];
    }
    return ObjectAnnotationTypeDeclaration;
})(datamodel.ObjectTypeDeclaration);
exports.ObjectAnnotationTypeDeclaration = ObjectAnnotationTypeDeclaration;
var StringAnnotationTypeDeclaration = (function (_super) {
    __extends(StringAnnotationTypeDeclaration, _super);
    function StringAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["ValueAnnotationTypeDeclaration"])];
    }
    return StringAnnotationTypeDeclaration;
})(datamodel.StringTypeDeclaration);
exports.StringAnnotationTypeDeclaration = StringAnnotationTypeDeclaration;
var BooleanAnnotationTypeDeclaration = (function (_super) {
    __extends(BooleanAnnotationTypeDeclaration, _super);
    function BooleanAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["ValueAnnotationTypeDeclaration"])];
    }
    return BooleanAnnotationTypeDeclaration;
})(datamodel.BooleanTypeDeclaration);
exports.BooleanAnnotationTypeDeclaration = BooleanAnnotationTypeDeclaration;
var ValueAnnotationTypeDeclaration = (function (_super) {
    __extends(ValueAnnotationTypeDeclaration, _super);
    function ValueAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["AnnotationTypeDeclaration"])];
    }
    return ValueAnnotationTypeDeclaration;
})(datamodel.ValueTypeDeclaration);
exports.ValueAnnotationTypeDeclaration = ValueAnnotationTypeDeclaration;
var NumberAnnotationTypeDeclaration = (function (_super) {
    __extends(NumberAnnotationTypeDeclaration, _super);
    function NumberAnnotationTypeDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["ValueAnnotationTypeDeclaration"])];
    }
    return NumberAnnotationTypeDeclaration;
})(datamodel.NumberTypeDeclaration);
exports.NumberAnnotationTypeDeclaration = NumberAnnotationTypeDeclaration;
var RAMLExpressionAnnotation = (function (_super) {
    __extends(RAMLExpressionAnnotation, _super);
    function RAMLExpressionAnnotation() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["AnnotationTypeDeclaration"])];
    }
    return RAMLExpressionAnnotation;
})(datamodel.RAMLExpression);
exports.RAMLExpressionAnnotation = RAMLExpressionAnnotation;
var DateTypeAnnotationDeclaration = (function (_super) {
    __extends(DateTypeAnnotationDeclaration, _super);
    function DateTypeAnnotationDeclaration() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.superclasses(["AnnotationTypeDeclaration"])];
    }
    return DateTypeAnnotationDeclaration;
})(datamodel.DateTypeDeclaration);
exports.DateTypeAnnotationDeclaration = DateTypeAnnotationDeclaration;
//# sourceMappingURL=declarations.js.map