import datamodel = require("./datamodel");
export declare class ValueType {
    parse(): any;
}
export declare class StringType extends ValueType {
    $: void[];
    value(): string;
}
export declare class AnyType extends ValueType {
    $: void[];
    value(): any;
}
export declare class NumberType extends ValueType {
    $: void[];
}
export declare class BooleanType extends ValueType {
    $: void[];
}
export interface Referencable<T> {
}
export declare class Reference<T> extends ValueType {
    structuredValue: datamodel.TypeInstance;
    $structuredValue: void[];
    name: string;
    $name: void[];
}
export interface DeclaresDynamicType<T> extends Referencable<T> {
}
export declare class UriTemplate extends StringType {
    $: void[];
}
export declare class StatusCodeString extends StringType {
}
export declare class RelativeUriString extends UriTemplate {
    $: void[];
}
export declare class FullUriTemplateString extends UriTemplate {
    $: void[];
    validate(): void;
}
export declare class FixedUriString extends StringType {
    $: void[];
}
export declare class ContentType extends StringType {
}
export declare class ValidityExpression extends StringType {
}
export declare class MarkdownString extends StringType {
    $: void[];
}
export declare class DateFormatSpec extends StringType {
}
export declare class FunctionalInterface extends StringType {
}
export declare class SchemaString extends StringType {
    $: void[];
    validate(): void;
}
export declare class ExampleString extends StringType {
    $: void[];
    validate(): void;
}
export declare class JSonSchemaString extends SchemaString {
    $: void[];
}
export declare class XMLSchemaString extends SchemaString {
    $: void[];
}
export declare class RAMLSelector extends StringType {
}
