import Sys = require("./systemTypes");
import Params = require("./parameters");
import Common = require("./common");
export interface MimeTypeModel {
    type: string;
    tree?: string;
    subtype: string;
    suffix?: string;
    parameters?: string;
}
export declare class MimeType extends Sys.StringType {
    isForm(): boolean;
    isXML(): boolean;
    isJSON(): boolean;
    $: void[];
}
export declare class BodyLike extends Common.RAMLLanguageElement {
    name: string;
    $name: void[];
    schema: Sys.SchemaString;
    $schema: void[];
    example: Sys.ExampleString;
    $example: void[];
    formParameters: Params.Parameter[];
    $formParameters: void[];
    $: void[];
    schemaContent: string;
    $schemaContent: void[];
}
export declare class XMLBody extends BodyLike {
    schema: Sys.XMLSchemaString;
    $schema: void[];
    $: void[];
}
export declare class JSONBody extends BodyLike {
    schema: Sys.JSonSchemaString;
    $schema: void[];
    $: void[];
}
export declare class Response extends Common.RAMLLanguageElement {
    code: Sys.StatusCodeString;
    $code: void[];
    headers: Params.Parameter[];
    $headers: void[];
    body: BodyLike[];
    $body: void[];
}
