export declare class ValueType {
    parse(): any;
}
export declare class StringType extends ValueType {
    $: void[];
    value(): string;
}
export declare class AnyType extends ValueType {
    $: void[];
    value(): any;
}
export declare class NumberType extends ValueType {
    $: void[];
}
export declare class BooleanType extends ValueType {
    $: void[];
}
export interface Referencable<T> {
}
export declare class Reference<T> extends ValueType {
    structuredValue: TypeInstance;
    $structuredValue: void[];
    name: string;
    $name: void[];
}
export interface DeclaresDynamicType<T> extends Referencable<T> {
}
export declare class UriTemplate extends StringType {
    $: void[];
    templateArguments(): string[];
    validate(): void;
}
export declare class RelativeUriString extends UriTemplate {
    $: void[];
    parse(): string[];
}
export declare class FullUriTemplateString extends UriTemplate {
    $: void[];
    parse(): string[];
    validate(): void;
}
export declare class FixedUri extends StringType {
    $: void[];
}
export declare class MarkdownString extends StringType {
    $: void[];
}
export declare class SchemaString extends StringType {
    $: void[];
    validate(): void;
}
export declare class JSonSchemaString extends SchemaString {
    $: void[];
}
export declare class XMLSchemaString extends SchemaString {
    $: void[];
}
export declare class ExampleString extends StringType {
}
export declare class StatusCodeString extends StringType {
}
export declare class JSONExample extends ExampleString {
    $: void[];
    $$: any;
    parse(): any;
}
export declare class XMLExample extends ExampleString {
    $: void[];
}
export declare class TypeInstance {
    $: void[];
    properties: TypeInstanceProperty[];
    $properties: void[];
    isScalar: boolean;
    $isScalar: void[];
    value: any;
    $value: void[];
}
export declare class TypeInstanceProperty {
    $: void[];
    name: string;
    $name: void[];
    value: TypeInstance;
    $value: void[];
    values: TypeInstance[];
    $values: void[];
    isArray: boolean;
    $isArray: void[];
}
