var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var ValueType = (function () {
    function ValueType() {
    }
    ValueType.prototype.parse = function () { };
    return ValueType;
})();
exports.ValueType = ValueType;
var StringType = (function (_super) {
    __extends(StringType, _super);
    function StringType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("string")];
    }
    StringType.prototype.value = function () { return null; };
    return StringType;
})(ValueType);
exports.StringType = StringType;
var AnyType = (function (_super) {
    __extends(AnyType, _super);
    function AnyType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("any")];
    }
    AnyType.prototype.value = function () { return null; };
    return AnyType;
})(ValueType);
exports.AnyType = AnyType;
var NumberType = (function (_super) {
    __extends(NumberType, _super);
    function NumberType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("number")];
    }
    return NumberType;
})(ValueType);
exports.NumberType = NumberType;
var BooleanType = (function (_super) {
    __extends(BooleanType, _super);
    function BooleanType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("boolean")];
    }
    return BooleanType;
})(ValueType);
exports.BooleanType = BooleanType;
var Reference = (function (_super) {
    __extends(Reference, _super);
    function Reference() {
        _super.apply(this, arguments);
        this.$structuredValue = [MetaModel.customHandling(), MetaModel.description("Returns a structured object if the reference point to one.")];
        this.$name = [MetaModel.customHandling(), MetaModel.description("Returns name of referenced object")];
    }
    return Reference;
})(ValueType);
exports.Reference = Reference;
var UriTemplate = (function (_super) {
    __extends(UriTemplate, _super);
    function UriTemplate() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This type currently serves both for absolute and relative urls")];
    }
    UriTemplate.prototype.templateArguments = function () {
        var pos = 0;
        var str = this.value();
        var result = [];
        while (true) {
            var start = str.indexOf("{", pos);
            if (start != -1) {
                var end = str.indexOf("}", start + 1);
                result.push(str.substring(start + 1, end));
                pos = end;
            }
            else {
                break;
            }
        }
        return result;
    };
    UriTemplate.prototype.validate = function () {
        var str = this.value();
    };
    return UriTemplate;
})(StringType);
exports.UriTemplate = UriTemplate;
var RelativeUriString = (function (_super) {
    __extends(RelativeUriString, _super);
    function RelativeUriString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This  type describes relative uri templates")];
    }
    RelativeUriString.prototype.parse = function () {
        var value = this.value();
        var result = [];
        var temp = "";
        var inPar = false;
        var count = 0;
        for (var a = 0; a < value.length; a++) {
            var c = value[a];
            if (c == '{') {
                count++;
                inPar = true;
                continue;
            }
            if (c == '}') {
                count--;
                inPar = false;
                result.push(temp);
                temp = "";
                continue;
            }
            if (inPar) {
                temp += c;
            }
        }
        if (count > 0) {
            throw new Error("Unmatched '{'");
        }
        if (count < 0) {
            throw new Error("Unmatched '}'");
        }
        return result;
    };
    return RelativeUriString;
})(UriTemplate);
exports.RelativeUriString = RelativeUriString;
var FullUriTemplateString = (function (_super) {
    __extends(FullUriTemplateString, _super);
    function FullUriTemplateString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This  type describes absolute uri templates")];
    }
    FullUriTemplateString.prototype.parse = function () {
        var value = this.value();
        var result = [];
        var temp = "";
        var inPar = false;
        var count = 0;
        for (var a = 0; a < value.length; a++) {
            var c = value[a];
            if (c == '{') {
                count++;
                inPar = true;
                continue;
            }
            if (c == '}') {
                count--;
                inPar = false;
                result.push(temp);
                temp = "";
                continue;
            }
            if (inPar) {
                temp += c;
            }
        }
        if (count > 0) {
            throw new Error("Unmatched '{'");
        }
        if (count < 0) {
            throw new Error("Unmatched '}'");
        }
        return result;
    };
    FullUriTemplateString.prototype.validate = function () {
        var str = this.value();
    };
    return FullUriTemplateString;
})(UriTemplate);
exports.FullUriTemplateString = FullUriTemplateString;
var FixedUri = (function (_super) {
    __extends(FixedUri, _super);
    function FixedUri() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This  type describes fixed uris")];
    }
    return FixedUri;
})(StringType);
exports.FixedUri = FixedUri;
var MarkdownString = (function (_super) {
    __extends(MarkdownString, _super);
    function MarkdownString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.innerType("markdown"),
            MetaModel.description("Mardown string is a string which can contain markdown as an extension this markdown should support links with RAML Pointers since 1.0")
        ];
    }
    return MarkdownString;
})(StringType);
exports.MarkdownString = MarkdownString;
var SchemaString = (function (_super) {
    __extends(SchemaString, _super);
    function SchemaString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("Schema at this moment only two subtypes are supported (json schema and xsd)")];
    }
    SchemaString.prototype.validate = function () {
        var str = this.value();
    };
    return SchemaString;
})(StringType);
exports.SchemaString = SchemaString;
var JSonSchemaString = (function (_super) {
    __extends(JSonSchemaString, _super);
    function JSonSchemaString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.functionalDescriminator("this.mediaType&&this.mediaType.isJSON()"), MetaModel.description("JSON schema")];
    }
    return JSonSchemaString;
})(SchemaString);
exports.JSonSchemaString = JSonSchemaString;
var XMLSchemaString = (function (_super) {
    __extends(XMLSchemaString, _super);
    function XMLSchemaString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.innerType("xml"), MetaModel.description("XSD schema")];
    }
    return XMLSchemaString;
})(SchemaString);
exports.XMLSchemaString = XMLSchemaString;
var ExampleString = (function (_super) {
    __extends(ExampleString, _super);
    function ExampleString() {
        _super.apply(this, arguments);
    }
    return ExampleString;
})(StringType);
exports.ExampleString = ExampleString;
var StatusCodeString = (function (_super) {
    __extends(StatusCodeString, _super);
    function StatusCodeString() {
        _super.apply(this, arguments);
    }
    return StatusCodeString;
})(StringType);
exports.StatusCodeString = StatusCodeString;
var JSONExample = (function (_super) {
    __extends(JSONExample, _super);
    function JSONExample() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.functionalDescriminator("this.mediaType.isJSON()")];
    }
    JSONExample.prototype.parse = function () {
        try {
            JSON.parse(this.value());
        }
        catch (e) {
            var ne = new Error("Warning: Can not parse JSON:" + e.message);
            throw ne;
        }
        var a = this.$$.parent().attr('schema');
        if (a) {
            var sm = a.findReferencedValue();
            if (sm && sm.validate) {
                sm.validate(this.value());
            }
        }
    };
    return JSONExample;
})(ExampleString);
exports.JSONExample = JSONExample;
var XMLExample = (function (_super) {
    __extends(XMLExample, _super);
    function XMLExample() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.functionalDescriminator("this.mediaType.isXML()")];
    }
    return XMLExample;
})(ExampleString);
exports.XMLExample = XMLExample;
var TypeInstance = (function () {
    function TypeInstance() {
        this.$ = [MetaModel.customHandling()];
        this.$properties = [MetaModel.description("Array of instance properties")];
        this.$isScalar = [MetaModel.description("Whether the type is scalar")];
        this.$value = [MetaModel.description("For instances of scalar types returns scalar value")];
    }
    return TypeInstance;
})();
exports.TypeInstance = TypeInstance;
var TypeInstanceProperty = (function () {
    function TypeInstanceProperty() {
        this.$ = [MetaModel.customHandling()];
        this.$name = [MetaModel.description("Property name")];
        this.$value = [MetaModel.description("Property value")];
        this.$values = [MetaModel.description("Array of values if property value is array")];
        this.$isArray = [MetaModel.description("Whether property has array as value")];
    }
    return TypeInstanceProperty;
})();
exports.TypeInstanceProperty = TypeInstanceProperty;
//# sourceMappingURL=systemTypes.js.map