import Sys = require("./systemTypes");
import RM = require("./methodsAndResources");
import Common = require("./common");
import models = require("./datamodel");
import declarations = require("./declarations");
export declare class GlobalSchema extends Common.RAMLSimpleElement implements Sys.Referencable<Sys.SchemaString> {
    key: string;
    $key: void[];
    value: Sys.SchemaString;
    $value: void[];
    $: void[];
}
export declare class ImportDeclaration extends Common.RAMLSimpleElement {
    key: string;
    $key: void[];
    value: Library;
    $value: void[];
}
export declare class Library extends LibraryBase {
    usage: string;
    $usage: void[];
    name: string;
    $name: void[];
}
export declare class LibraryBase extends Common.RAMLLanguageElement {
    $: void[];
    schemas: GlobalSchema[];
    $schemas: void[];
    types: models.TypeDeclaration[];
    $types: void[];
    traits: RM.Trait[];
    $traits: void[];
    resourceTypes: RM.ResourceType[];
    $resourceTypes: void[];
    annotationTypes: declarations.AnnotationTypeDeclaration[];
    $annotationTypes: void[];
    securitySchemes: RM.AbstractSecurityScheme[];
    $securitySchemes: void[];
    uses: Library[];
    $uses: void[];
}
