var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var Sys = require("./systemTypes");
var models = require("./datamodel");
var Common = require("./common");
var MimeType = (function (_super) {
    __extends(MimeType, _super);
    function MimeType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This sub type of the string represents mime types")];
    }
    MimeType.prototype.isForm = function () {
        if (this.value() == "application/x-www-form-urlencoded" || this.value() == 'multipart/form-data') {
            return true;
        }
        return false;
    };
    MimeType.prototype.isXML = function () {
        if (this.value() == "application/xml") {
            return true;
        }
        return false;
    };
    MimeType.prototype.isJSON = function () {
        if (this.value() == "application/json") {
            return true;
        }
        return false;
    };
    return MimeType;
})(Sys.StringType);
exports.MimeType = MimeType;
var Response = (function (_super) {
    __extends(Response, _super);
    function Response() {
        _super.apply(this, arguments);
        this.$code = [
            MetaModel.key(),
            MetaModel.extraMetaKey("statusCodes"),
            MetaModel.description("Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."),
            MetaModel.hide()
        ];
        this.$headers = [MetaModel.setsContextValue("fieldOrParam", true), MetaModel.setsContextValue("location", models.ModelLocation.HEADERS),
            MetaModel.setsContextValue("locationKind", models.LocationKind.APISTRUCTURE),
            MetaModel.newInstanceName("New Header"),
            MetaModel.description("Detailed information about any response headers returned by this method"),
            MetaModel.valueDescription("Object whose property names are the response header names and whose values describe the values.")
        ];
        this.$body = [
            MetaModel.newInstanceName("New Body"),
            MetaModel.description("The body of the response: a body declaration"),
            MetaModel.valueDescription("Object whose properties are either<br>* Media types and whose values are type objects describing the request body for that media type, or<br>* a type object describing the request body for the default media type specified in the root mediaType property.")
        ];
        this.$displayName = [MetaModel.description("An alternate, human-friendly name for the response")];
        this.$description = [
            MetaModel.description("A longer, human-friendly description of the response"),
            MetaModel.valueDescription("Markdown string")
        ];
        this.$annotations = [
            MetaModel.markdownDescription("Annotations to be applied to this response. Annotations are any property whose key begins with \"(\" and ends with \")\" and whose name (the part between the beginning and ending parentheses) is a declared annotation name. See the [[raml-10-spec-annotations|section on annotations]].")
        ];
    }
    return Response;
})(Common.RAMLLanguageElement);
exports.Response = Response;
//# sourceMappingURL=bodies.js.map