var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var Common = require("./common");
var datamodel = require("./datamodel");
var index = {
    title: "Named Parameters"
};
var FileTypeDeclaration = (function (_super) {
    __extends(FileTypeDeclaration, _super);
    function FileTypeDeclaration() {
        _super.apply(this, arguments);
        this.type = "file";
        this.$fileTypes = [MetaModel.description("It should also include a new property: fileTypes, which should be a list of valid content-type strings for the file. The file type */* should be a valid value.")];
        this.$minLength = [MetaModel.description("The minLength attribute specifies the parameter value's minimum number of bytes.")];
        this.$maxLength = [MetaModel.description("The maxLength attribute specifies the parameter value's maximum number of bytes.")];
        this.$ = [
            MetaModel.description("(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly.")];
    }
    return FileTypeDeclaration;
})(datamodel.TypeDeclaration);
exports.FileTypeDeclaration = FileTypeDeclaration;
var HasNormalParameters = (function (_super) {
    __extends(HasNormalParameters, _super);
    function HasNormalParameters() {
        _super.apply(this, arguments);
        this.$queryParameters = [
            MetaModel.setsContextValue("fieldOrParam", true),
            MetaModel.setsContextValue("location", datamodel.ModelLocation.QUERY),
            MetaModel.setsContextValue("locationKind", datamodel.LocationKind.APISTRUCTURE),
            MetaModel.newInstanceName("New query parameter"), MetaModel.description('An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming' +
                ' a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property')];
        this.$headers = [
            MetaModel.setsContextValue("fieldOrParam", true),
            MetaModel.setsContextValue("location", datamodel.ModelLocation.HEADERS),
            MetaModel.setsContextValue("locationKind", datamodel.LocationKind.APISTRUCTURE),
            MetaModel.description("Headers that allowed at this position"),
            MetaModel.newInstanceName("New Header")];
        this.$queryString = [MetaModel.description("Specifies the query string needed by this method. Mutually exclusive with queryParameters.")];
    }
    return HasNormalParameters;
})(Common.RAMLLanguageElement);
exports.HasNormalParameters = HasNormalParameters;
//# sourceMappingURL=parameters.js.map