var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var MetaModel = require("../metamodel");
var ValueType = (function () {
    function ValueType() {
    }
    ValueType.prototype.parse = function () { };
    return ValueType;
})();
exports.ValueType = ValueType;
var StringType = (function (_super) {
    __extends(StringType, _super);
    function StringType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("string"), MetaModel.alias("string")];
    }
    StringType.prototype.value = function () { return null; };
    return StringType;
})(ValueType);
exports.StringType = StringType;
var AnyType = (function (_super) {
    __extends(AnyType, _super);
    function AnyType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("any"), MetaModel.alias("any")];
    }
    AnyType.prototype.value = function () { return null; };
    return AnyType;
})(ValueType);
exports.AnyType = AnyType;
var NumberType = (function (_super) {
    __extends(NumberType, _super);
    function NumberType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("number"), MetaModel.alias("integer"), MetaModel.alias("number")];
    }
    return NumberType;
})(ValueType);
exports.NumberType = NumberType;
var BooleanType = (function (_super) {
    __extends(BooleanType, _super);
    function BooleanType() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.nameAtRuntime("boolean"), MetaModel.alias("boolean")];
    }
    return BooleanType;
})(ValueType);
exports.BooleanType = BooleanType;
var Reference = (function (_super) {
    __extends(Reference, _super);
    function Reference() {
        _super.apply(this, arguments);
        this.$structuredValue = [MetaModel.customHandling(), MetaModel.description("Returns a structured object if the reference point to one.")];
        this.$name = [MetaModel.customHandling(), MetaModel.description("Returns name of referenced object")];
    }
    return Reference;
})(ValueType);
exports.Reference = Reference;
var UriTemplate = (function (_super) {
    __extends(UriTemplate, _super);
    function UriTemplate() {
        _super.apply(this, arguments);
        this.$ = [
            MetaModel.description("This type currently serves both for absolute and relative urls")
        ];
    }
    return UriTemplate;
})(StringType);
exports.UriTemplate = UriTemplate;
var StatusCodeString = (function (_super) {
    __extends(StatusCodeString, _super);
    function StatusCodeString() {
        _super.apply(this, arguments);
    }
    return StatusCodeString;
})(StringType);
exports.StatusCodeString = StatusCodeString;
var RelativeUriString = (function (_super) {
    __extends(RelativeUriString, _super);
    function RelativeUriString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This  type describes relative uri templates")];
    }
    return RelativeUriString;
})(UriTemplate);
exports.RelativeUriString = RelativeUriString;
var FullUriTemplateString = (function (_super) {
    __extends(FullUriTemplateString, _super);
    function FullUriTemplateString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This  type describes absolute uri templates")];
    }
    FullUriTemplateString.prototype.validate = function () {
        var str = this.value();
    };
    return FullUriTemplateString;
})(UriTemplate);
exports.FullUriTemplateString = FullUriTemplateString;
var FixedUriString = (function (_super) {
    __extends(FixedUriString, _super);
    function FixedUriString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("This  type describes fixed uris")];
    }
    return FixedUriString;
})(StringType);
exports.FixedUriString = FixedUriString;
var ContentType = (function (_super) {
    __extends(ContentType, _super);
    function ContentType() {
        _super.apply(this, arguments);
    }
    return ContentType;
})(StringType);
exports.ContentType = ContentType;
var ValidityExpression = (function (_super) {
    __extends(ValidityExpression, _super);
    function ValidityExpression() {
        _super.apply(this, arguments);
    }
    return ValidityExpression;
})(StringType);
exports.ValidityExpression = ValidityExpression;
var MarkdownString = (function (_super) {
    __extends(MarkdownString, _super);
    function MarkdownString() {
        _super.apply(this, arguments);
        this.$ = [
            MetaModel.innerType("markdown"),
            MetaModel.description("[GitHub Flavored Markdown](https://help.github.com/articles/github-flavored-markdown/)")
        ];
    }
    return MarkdownString;
})(StringType);
exports.MarkdownString = MarkdownString;
var DateFormatSpec = (function (_super) {
    __extends(DateFormatSpec, _super);
    function DateFormatSpec() {
        _super.apply(this, arguments);
    }
    return DateFormatSpec;
})(StringType);
exports.DateFormatSpec = DateFormatSpec;
var FunctionalInterface = (function (_super) {
    __extends(FunctionalInterface, _super);
    function FunctionalInterface() {
        _super.apply(this, arguments);
    }
    return FunctionalInterface;
})(StringType);
exports.FunctionalInterface = FunctionalInterface;
var SchemaString = (function (_super) {
    __extends(SchemaString, _super);
    function SchemaString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("Schema at this moment only two subtypes are supported (json schema and xsd)"), MetaModel.alias("schema")];
    }
    SchemaString.prototype.validate = function () {
        var str = this.value();
    };
    return SchemaString;
})(StringType);
exports.SchemaString = SchemaString;
var ExampleString = (function (_super) {
    __extends(ExampleString, _super);
    function ExampleString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.description("Examples at this moment only two subtypes are supported (json  and xml)")];
    }
    ExampleString.prototype.validate = function () {
        var str = this.value();
    };
    return ExampleString;
})(StringType);
exports.ExampleString = ExampleString;
var JSonSchemaString = (function (_super) {
    __extends(JSonSchemaString, _super);
    function JSonSchemaString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.innerType("json"), MetaModel.description("JSON schema")];
    }
    return JSonSchemaString;
})(SchemaString);
exports.JSonSchemaString = JSonSchemaString;
var XMLSchemaString = (function (_super) {
    __extends(XMLSchemaString, _super);
    function XMLSchemaString() {
        _super.apply(this, arguments);
        this.$ = [MetaModel.innerType("xsd"), MetaModel.description("XSD schema")];
    }
    return XMLSchemaString;
})(SchemaString);
exports.XMLSchemaString = XMLSchemaString;
var RAMLSelector = (function (_super) {
    __extends(RAMLSelector, _super);
    function RAMLSelector() {
        _super.apply(this, arguments);
    }
    return RAMLSelector;
})(StringType);
exports.RAMLSelector = RAMLSelector;
//# sourceMappingURL=systemTypes.js.map